//
// Created by martin on 10. 9. 2021.
//

#ifndef ARC_SUPPORT_UTILITY_H
#define ARC_SUPPORT_UTILITY_H


#include <vector>
#include <opencv2/core/types.hpp>

/**
 * a structure to store ellipse parameters
 */
struct ellipseParameters {
    cv::Point2i center; // center of an ellipse
    double major = 0; // semi major axis
    double minor = 0; // semi minor axis
    double theta = 0; // rotation of the ellipse
};


/**
 * @param x1 is x coordinate of first point
 * @param y1 is y coordinate of first point
 * @param x2 is x coordinate of second point
 * @param y2 is x coordinate of second point
 */
double distance(const double x1, const double y1, const double x2, const double y2);

#endif //ARC_SUPPORT_UTILITY_H
